
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>.NET ORM 的 “SOD蜜”--零基础入门篇 / 憋错料</title>

    <meta name="description" content=".NET ORM 的 “SOD蜜”--零基础入门篇 PDF.NET SOD框架不仅仅是一个ORM,但是它的ORM功能是独具特色的,我在博客中已经多次介绍,但都是原理性的,可能不少初学的朋友还是觉得复杂,其实,SOD的ORM是很简单的.下面我们就采用流行的 Code First的方式,一步步来了解下. 一.准备工作 1.1,添加SOD包引用 首先建立一个控制台项目,并使用程序包管理器添加PDF.NET SOD的程序引用: PM&gt; Install-Package PDF.NET 更多详细使用信息说明,请参考nuget 网站说明 https:// ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">.NET ORM 的 “SOD蜜”--零基础入门篇</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>PDF.NET SOD框架不仅仅是一个ORM,但是它的ORM功能是独具特色的,我在博客中已经多次介绍,但都是原理性的,可能不少初学的朋友还是觉得复杂,其实,SOD的ORM是很简单的。下面我们就采用流行的 Code First的方式，一步步来了解下。</p>
<h1>一、准备工作</h1>
<h2>1.1，添加SOD包引用</h2>
<p>首先建立一个控制台项目，并使用程序包管理器添加PDF.NET SOD的程序引用：</p>
<p>PM&gt; Install-Package PDF.NET</p>
<p>更多详细使用信息说明，请参考nuget 网站说明 <a href="https://www.nuget.org/packages/PDF.NET/" rel="external nofollow noreferrer">https://www.nuget.org/packages/PDF.NET/</a></p>
<h2>1.2，配置数据连接</h2>
<p>新建一个控制台项目，添加一个应用程序配置文件，增加一个数据库连接配置：</p>
<pre>&lt;?xml version="1.0" encoding="utf-8" ?&gt;
&lt;configuration&gt;
    &lt;connectionStrings&gt;
        &lt;add name="local" connectionString="Data Source=.;Initial Catalog=LocalDB;Integrated Security=True" providerName="SqlServer" /&gt;
    &lt;/connectionStrings&gt;
&lt;/configuration&gt;</pre>
<p>确保你本地有SqlServer数据库，并且版本是2005以上，有一个数据库名字是 LocalDB,当然你可以修改成你实际的连接字符串。</p>
<p>之后，我们的查询示例，都将采用这个连接配置。</p>
<h2>1.3，定义实体类</h2>
<p>我们将使用用最常见的用户登录来举例，这里需要一个用户实体类，假设它的定义是下面这个样子的：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvQ29udHJhY3RlZEJsb2NrLmdpZg==.jpg" /><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuYmxvZ3MuY29tL091dGxpbmluZ0luZGljYXRvcnMvRXhwYW5kZWRCbG9ja1N0YXJ0LmdpZg==.jpg" /></p>

<pre>public class User : EntityBase
    {
        public User()
        {
            TableName="Tb_User";
            IdentityName = "UserID";
            PrimaryKeys.Add("UserID");
        }

        public int ID
        {
            get { return getProperty&lt;int&gt;("UserID"); }
            set { setProperty("UserID", value); }
        }

        public string Name
        {
            get { return getProperty&lt;string&gt;("Name"); }
            set { setProperty("Name", value, 50); }
        }

        public string Pwd
        {
            get { return getProperty&lt;string&gt;("Pwd"); }
            set { setProperty("Pwd", value, 50); }
        }

        public DateTime RegistedDate
        {
            get { return getProperty&lt;DateTime&gt;("RegistedDate"); }
            set { setProperty("RegistedDate", value); }
        }

    }</pre>
<p></p>
<h2>1.4，添加查询对象的数据上下文</h2>
<p>在项目中添加一个 LocalDbContext.cs 文件，文件中添加如下代码，以便检查表 Tb_User 是否存在，如果不存在，则自动创建一个：</p>
<pre>/// &lt;summary&gt;
 /// 用来测试的本地SqlServer 数据库上下文类
 /// &lt;/summary&gt;
  public class LocalDbContext : SqlServerDbContext
  {
      public LocalDbContext()
          : base("local")
      {
          //local 是连接字符串名字
      }

      #region 父类抽象方法的实现

      protected override bool CheckAllTableExists()
      {
          //创建用户表
          CheckTableExists&lt;User&gt;();
          return true;
      }

      #endregion
   }</pre>
<p>本例中使用SqlServer 作为查询示例，所以该处使用 SqlServerDbContext 抽象类为基类。</p>
<h2>1.5，创建数据库表</h2>
<p>OK，基本准备就绪，现在Main 方法里面可以写下面的代码开始工作了：</p>
<pre>LocalDbContext context = new LocalDbContext();//自动创建表</pre>
<p>准备工作全部完成，运行这一句代码，之后查看SqlServer管理工具，发现表 Tb_User 已经创建了。</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzExNDUxNy8yMDE1MDMvMDEyMzMxMTAwMzQ1NDE4LnBuZw==.jpg" /></p>
<h1>二、ORM之增，删，改</h1>
<p>SOD框架的ORM功能跟通常的ORM框架不同，SOD框架的实体类上并没有数据查询和持久化的方法，所以SOD的实体类是&ldquo;非常纯粹的&rdquo;实体类，你可以把它看作是一个数据容器，或者用来当作DTO，ViewModel使用，有关这个话题更详细的阐述，请看这篇文章：《<a href="http://www.cnblogs.com/bluedoctor/p/4286707.html" rel="external nofollow noreferrer">DataSet的灵活,实体类的方便，DTO的效率：SOD框架的数据容器，打造最适合DDD的ORM框架</a>》。</p>
<p>在进行真正的数据查询之前，得先有数据，所以我们先测试数据的增删改。</p>
<h2>2.1，删除数据</h2>
<p>首先删除之前的测试数据，可以采用OQL进行批量数据删除：</p>
<pre>int count = 0;

//删除 测试数据-----------------------------------------------------
User user = new User();
OQL deleteQ = OQL.From(user)
                .Delete()
                .Where(cmp =&gt; cmp.Comparer(user.ID, "&gt;", 0)) //为了安全，不带Where条件是不会全部删除数据的
             .END;
count= EntityQuery&lt;User&gt;.ExecuteOql(deleteQ, context.CurrentDataBase);</pre>
<p>这里将用户ID 大于0的数据全部删除了，框架内置了数据安全机制，不会随意删除全部数据，所以为了清除全部数据，采用了上面的方法。</p>
<h2>2.2，增加数据</h2>
<p>方式1，采用DbContext 的Add 方法：</p>
<pre>            count = 0;
            User zhang_san = new User() { Name = "zhang san", Pwd = "123" };
            count += context.Add&lt;User&gt;(zhang_san);//采用 DbContext 方式插入数据</pre>
<p>方式2，采用OQL：</p>
<pre>            User li_si = new User() { Name = "li si", Pwd = "123" };
            OQL insertQ= OQL.From(li_si)
                            .Insert(li_si.Name);//仅仅插入用户名，不插入密码</pre>
<p>OQL还需EntityQuery 对象配合，才可以执行，继续看下面的代码：</p>
<pre> AdoHelper db = MyDB.GetDBHelperByConnectionName("local");
 EntityQuery&lt;User&gt; userQuery = new EntityQuery&lt;User&gt;(db);
 count += userQuery.ExecuteOql(insertQ);</pre>
<p>下面是结果图：</p>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1hZ2VzLmNuaXRibG9nLmNvbS9ibG9nLzExNDUxNy8yMDE1MDMvMDEyMzMyMjEyNjg1MTIzLnBuZw==.jpg" /></p>
<p>方式3，直接EntityQuery 插入实体类：</p>
<pre> User zhang_yeye = new User() { Name = "zhang yeye", Pwd = "456" };
 count += EntityQuery&lt;User&gt;.Instance.Insert(zhang_yeye);//采用泛型 EntityQuery 方式插入数据</pre>

<h2>2.3，修改数据：</h2>
<p>方式1，采用 DbContext 方式更新数据</p>
<pre> li_si.Pwd = "123123";
 count = context.Update&lt;User&gt;(li_si);//采用 DbContext 方式更新数据</pre>
<p>方式2，采用OQL方式更新指定的数据</p>
<pre> li_si.Pwd = "123456";
OQL updateQ= OQL.From(li_si)
                .Update(li_si.Pwd) //仅仅更新密码
             .END;
count += EntityQuery&lt;User&gt;.Instance.ExecuteOql(updateQ);//采用OQL方式更新指定的数据</pre>
<p>方式3，采用泛型 EntityQuery 方式修改数据</p>
<pre>  li_si.Pwd = "888888";
  count += EntityQuery&lt;User&gt;.Instance.Update(li_si);//采用泛型 EntityQuery 方式修改数据</pre>

<h1>三、ORM之数据查询</h1>
<p>前面增删改数据完成了，现在有了测试数据，我们可以来进行ORM的数据查询测试了，这里使用用户登录的例子来测试，框架提供了6种数据查询方式。</p>
<h2>3.1，最简单的方法</h2>
<p>假设前端直接传递了一个 User 实体类对象，中间设置了用户名和密码，现在有一个登录方法使用该对象，该方法详细内容如下所示：</p>
<pre>       /// &lt;summary&gt;
        /// 使用用户对象来登录，OQL最简单最常见的使用方式
        /// &lt;/summary&gt;
        /// &lt;param name="user"&gt;&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        public bool Login(User user)
        {
            OQL q = OQL.From(user)
                .Select()
                .Where(user.Name, user.Pwd) //以用户名和密码来验证登录
            .END;

            User dbUser =q.ToEntity&lt;User&gt;();//ToEntity，OQL扩展方法
            return dbUser != null; //查询到用户实体类，表示登录成功
        }</pre>
<p>这里我们使用了SOD框架的ORM查询语言--OQL，它的结构非常类似于SQL，你可以认为OQL就是对象化的SQL语句。</p>
<p>OQL表达式采用 .From.....END 的语法，对象的链式方法调用，只要敲点出来的就是正确的，这样没有SQL基础的同学也可以很快掌握该查询语法，也能马上作数据开发。</p>
<p>注意：在本例中，使用了OQL的扩展方法，因此需要引用下面的名字空间：</p>
<pre>using PWMIS.Core.Extensions;</pre>
<p>如果不使用扩展方法，可以采用泛型EntityQuery 的方法，请看下面的示例。</p>
<h2>3.2，使用 OQLCompare 对象的 EqualValue 相等比较方式</h2>

<pre>        /// &lt;summary&gt;
        /// 使用用户对象来登录，但是使用 OQLCompare 对象的 EqualValue 相等比较方式
        /// &lt;/summary&gt;
        /// &lt;param name="user"&gt;&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        public bool Login1(User user)
        {
            OQL q = OQL.From(user)
                 .Select(user.ID) //仅查询一个属性字段 ID
                 .Where(cmp =&gt; cmp.EqualValue(user.Name) &amp; cmp.EqualValue(user.Pwd))
              .END;

            User dbUser = EntityQuery&lt;User&gt;.QueryObject(q);
            return dbUser != null; //查询到用户实体类，表示登录成功
        }</pre>
<p>跟例1一样，这里也要求user 对象的Name和Pwd属性必须事先有值。本例没有使用OQL的扩展方法。</p>
<h2>3.3，&nbsp;EntityQuery 泛型查询方法</h2>
<p>本例只是对例子1做了下改进，重点在于登录方法的参数不是用户对象，而是名字和密码参数。</p>
<pre>       /// &lt;summary&gt;
        /// 使用用户名密码参数来登录，采用 EntityQuery 泛型查询方法
        /// &lt;/summary&gt;
        /// &lt;param name="name"&gt;&lt;/param&gt;
        /// &lt;param name="pwd"&gt;&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        public bool Login2(string name, string pwd)
        {
            User user = new User()
            {
                Name = name,
                Pwd = pwd
            };

            OQL q = OQL.From(user)
                .Select(user.ID)
                .Where(user.Name, user.Pwd)
            .END;
            User dbUser = EntityQuery&lt;User&gt;.QueryObject(q);

            return dbUser != null; //查询到用户实体类，表示登录成功
        }</pre>

<h2>4，使用OQLConditon 对象为查询条件</h2>

<pre>       /// &lt;summary&gt;
        /// 使用用户名密码参数来登录，使用早期的实例化OQL对象的方式，并使用OQLConditon 对象为查询条件
        /// &lt;/summary&gt;
        /// &lt;param name="name"&gt;&lt;/param&gt;
        /// &lt;param name="pwd"&gt;&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        public bool Login3(string name, string pwd)
        {
            User user = new User();
            OQL q = new OQL(user);
            q.Select(user.ID).Where(q.Condition.AND(user.Name, "=", name).AND(user.Pwd, "=", pwd));

            User dbUser = EntityQuery&lt;User&gt;.QueryObject(q);
            return dbUser != null; //查询到用户实体类，表示登录成功
        }</pre>
<p>这是OQL早期的条件查询方式，缺点是没法构造复杂的查询条件。</p>
<h2>5，操作符重载</h2>
<p>OQLCompare 的操作符重载可以简化比较条件，如下所示：</p>
<pre>       /// &lt;summary&gt;
        /// 使用用户名密码参数来登录，并使用操作符重载的查询条件比较方式
        /// &lt;/summary&gt;
        /// &lt;param name="name"&gt;&lt;/param&gt;
        /// &lt;param name="pwd"&gt;&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        public bool Login4(string name, string pwd)
        {
            User user = new User();

            OQL q = OQL.From(user)
                  .Select()
                  .Where( cmp =&gt; cmp.Property(user.Name) == name
                               &amp; cmp.Property(user.Pwd)  == pwd  )
               .END;

            User dbUser = EntityQuery&lt;User&gt;.QueryObject(q);
            return dbUser != null; //查询到用户实体类，表示登录成功
        }</pre>

<h2>6，使用泛型OQL查询（GOQL）</h2>
<p>使用泛型OQL查询（GOQL），对于单实体类查询最简单的使用方式，缺点是不能进行&ldquo;连表查询&rdquo;，即多个实体类联合查询。</p>
<pre>        /// &lt;summary&gt;
        /// 使用用户名密码参数来登录，使用泛型OQL查询（GOQL），对于单实体类查询最简单的使用方式。
        /// &lt;/summary&gt;
        /// &lt;param name="name"&gt;&lt;/param&gt;
        /// &lt;param name="pwd"&gt;&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        public bool Login5(string name, string pwd)
        {
            User dbUser = OQL.From&lt;User&gt;()
                 .Select()
                 .Where((cmp, user) =&gt; cmp.Property(user.Name) == name
                                     &amp; cmp.Property(user.Pwd)  == pwd  )
            .END
            .ToObject();

            return dbUser != null; //查询到用户实体类，表示登录成功
        }</pre>

<h2>7，使用实体类主键来查询</h2>
<p>SOD实体类的&ldquo;主键&rdquo;字段是可以修改的，这样你可以随时修改它，就像实体类本来的主键一样，用它来填充数据，本例就是判断是否填充成功当前实体类来判断用户是否可以登录。</p>
<pre>       /// &lt;summary&gt;
        /// 使用用户名密码参数来登录，但是根据实体类的主键来填充实体类并判断是否成功。
        /// &lt;/summary&gt;
        /// &lt;param name="name"&gt;&lt;/param&gt;
        /// &lt;param name="pwd"&gt;&lt;/param&gt;
        /// &lt;returns&gt;&lt;/returns&gt;
        public bool Login6(string name, string pwd)
        {
            User user = new User();
            user.PrimaryKeys.Clear();
            user.PrimaryKeys.Add("Name");
            user.PrimaryKeys.Add("Pwd");

            user.Name = name;
            user.Pwd = pwd;
            bool result= EntityQuery&lt;User&gt;.Fill(user);//静态方法，使用默认的连接对象
            return result;
        }</pre>

<h2>8，查询多条数据</h2>
<p>前面的例子都只是查询一条数据，如果需要查询多条数据也很简单，参见下面的例子，如何查询所有姓 zhang 的用户：</p>
<pre>        /// &lt;summary&gt;
        /// 模糊查询用户，返回用户列表，使用OQLCompare 委托
        /// &lt;/summary&gt;
        /// &lt;param name="likeName"&gt;要匹配的用户名&lt;/param&gt;
        /// &lt;returns&gt;用户列表&lt;/returns&gt;
        public List&lt;User&gt; FuzzyQueryUser(string likeName)
        {
            User user = new User();
            OQL q = OQL.From(user)
              .Select()
              .Where(cmp =&gt; cmp.Comparer(user.Name, "like", likeName+"%") )
            .END;

            List&lt;User&gt; users = EntityQuery&lt;User&gt;.QueryList(q);
            return users;
        }</pre>
<p>前端调用：</p>
<pre>//查询列表
var users=service.FuzzyQueryUser("zhang");
Console.WriteLine("模糊查询姓 张 的用户，数量:{0}",users.Count );</pre>
<p>所以，查询多条数据，仅需要使用泛型 EntityQuery对象的QueryList 方法即可。同样，框架也为你提供了OQL对象扩展方法来直接查询列表数据。</p>
<h2>9，实体类联合查询</h2>
<p>这里不再举例，我的博客文章也多次说明过，请参考下面这个系列文章：</p>
<p><a href="http://www.cnblogs.com/bluedoctor/p/3225176.html" rel="external nofollow noreferrer">ORM查询语言（OQL）简介--高级篇（续）：庐山真貌</a> 深蓝医生 2013-07-30 16:54 阅读:4497 评论:41</p>

<p><a href="http://www.cnblogs.com/bluedoctor/p/3216755.html" rel="external nofollow noreferrer">ORM查询语言（OQL）简介--高级篇：脱胎换骨</a> 深蓝医生 2013-07-26 17:26 阅读:3274 评论:28</p>

<p><a href="http://www.cnblogs.com/bluedoctor/archive/2013/04/01/2992981.html" rel="external nofollow noreferrer">ORM查询语言（OQL）简介--实例篇</a> 深蓝医生 2013-04-01 14:56 阅读:5108 评论:16</p>

<p><a href="http://www.cnblogs.com/bluedoctor/archive/2012/10/06/2712699.html" rel="external nofollow noreferrer">ORM查询语言（OQL）简介--概念篇</a> 深蓝医生 2012-10-06 00:58 阅读:4657 评论:25</p>

<h1>四、SOD框架的设计原则</h1>
<p>ＳＯＤ框架的整个设计都采用了&ldquo;<strong>条条道路通罗马</strong>&rdquo;的原则，即多模式解决方案，对数据的开发不管是SQL-MAP ,ORM,Data Control 哪种模式都可以&ldquo;<strong>殊途同归</strong>&rdquo;，对于ＯＱＬ，这个也得到了充分的体现，比如上面的用户登录功能，使用了7 种方式来实现，实际上还有3中查询方式本篇文章没有做成说明；而对于实体类的增，删，改，分别又提供了DbContext,OQL,泛型EntityQuery 等多种方式。</p>
<p>所以，SOD框架的使用非常灵活，你可以根据你的偏好，习惯，环境，来灵活使用，而且也容易扩展，因此，相对于EF这样的ORM框架来，SOD框架的ORM功能没有任何束缚，它自由，灵活，而且轻量，容易扩展，但不妨碍它的强大，比如对于分表分库的查询，数据的批量更新插入修改，数据库锁的直接支持等这些&ldquo;企业级&rdquo;数据开发需求的支持。</p>
<h1>五、相关资源</h1>
<p>本篇文章的源码，已经上传在了框架的开源项目 pwmis.codeplex.com 网站上，可以通过下面的地址查看完整的源码：</p>
<p><a href="http://pwmis.codeplex.com/SourceControl/latest#SOD/Test/SampleORMTest/Program.cs" rel="external nofollow noreferrer">http://pwmis.codeplex.com/SourceControl/latest#SOD/Test/SampleORMTest/Program.cs</a></p>
<p>源码下载，可以在下面的地址查看：</p>
<p><a href="http://pwmis.codeplex.com/releases/view/117822" rel="external nofollow noreferrer">http://pwmis.codeplex.com/releases/view/117822</a>&nbsp;<img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2Rvd25sb2FkLWNvZGVwbGV4LnNlYy5zLW1zZnQuY29tL0ltYWdlcy92MjA5NTkvRXhhbXBsZS5naWY=.jpg" />&nbsp;&nbsp;&nbsp;&nbsp; <a href="https://pwmis.codeplex.com/downloads/get/1435182" rel="external nofollow noreferrer">简单ORM示例程序--新手必读</a></p>
<p>有关框架更详细而完整的入门指引，请参考下面这篇文章：</p>
<p><a href="http://www.cnblogs.com/bluedoctor/p/4290570.html" rel="external nofollow noreferrer">PDF.NET SOD 开源框架红包派送活动 &amp;&amp; 新手快速入门指引</a></p>
<p>更多完整而详细的信息，请看框架官网地址：</p>
<p><a href="http://www.pwmis.com/sqlmap" rel="external nofollow noreferrer">http://www.pwmis.com/sqlmap</a></p>
<p>框架已经完全开源，参看这篇文章：</p>
<p><a href="http://www.cnblogs.com/bluedoctor/p/4273610.html" rel="external nofollow noreferrer">一年之计在于春，2015开篇：PDF.NET SOD Ver 5.1完全开源</a></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-20 06:34:21 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>.NET ORM 的 “SOD蜜”--零基础入门篇的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEvoPy0.html" rel="bookmark">Linux及Arm-Linux程序开发笔记（零基础入门篇）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Linux及Arm-Linux程序开发笔记(零基础入门篇)  作者:一点一滴的Beer http://beer.cnblogs.com/ 本文地址:http://www.cnblogs.com/beer/archive/2011/05/05/2037449.html 目录 一.Arm-Linux程序开发平台简要介绍... 3 1.1程序开发所需系统及开发语言... 3 1.2系统平台搭建方式... 4 二.Linux开发平台搭建... 5 2.1安装虚拟工作站... 5 2.2安装Linux虚拟			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/41kalY0.html" rel="bookmark">智能家居&mdash;&mdash;IoT零基础入门篇</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				概要 本文主要根据笔者从零开始接触硬件,以小白视角开启IoT探索,根据相关资料DIY一个温湿度传感器.后经过探索发现新大陆——Home Assistant&amp;Homebridge,最终实现了一个智能家居设备从数据采集到控制.展示. 整体结构图 智能设备:温湿度传感器 主控芯片:STM32F103C8T http://pic.cnhubei.com/space.php?uid=1913&amp;do=album&amp;id=1108908http://pic.cnhubei.com/space.ph			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/9496PDM.html" rel="bookmark">从零基础入门JavaScript（1）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				从零基础入门JavaScript(1) 1.1  Javascript的简史 1995年的时候   由网景公司开发的,当时的名字叫livescript    为了推广自己的livescript,搭了java顺风车,改名为javascript 与此同时,     微软因此在自身的浏览器里,也推出了自己的脚本语言 jscript 1997年时候,  由ECMA(欧洲计算机制造商协会)出面,推出了一套javascript的规范,Ecmascript ,规范提出js由三部分组成 JS的组成: ECMAS			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3rE91a0.html" rel="bookmark">鱼C《零基础入门学习Python》10-17节课时知识点总结</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				第10讲:列表:一个打了激素的数组 1. 列表都可以存放一些什么东西?  我们说 Python 的列表是一个打了激素的数组,如果把数组比喻成集装箱,那么 Python 的列表就是一个大仓库,Ta 可以存放我们已经学习过的任何数据类型. 2. 向列表增加元素有哪些方法?  三种方法想列表增加元素,分别是:append().extend() 和 insert().    3. append() 方法和 extend() 方法都是向列表的末尾增加元素,请问他们有什么区别?  append() 方法是将			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4NoZpwM.html" rel="bookmark">&period;NET零基础入门05：委托与事件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一:前言 本小节,我们需要停一停我们的小游戏开发,虽然它现在还不完美,还很简单,甚至还有BUG.但是,为了更好的理解C#,现在到了该深入了解一些基础知识的时候了. 当然,实际上,本小节内容对于零基础入门的初学者来说,还是有点难了.委托与事件,如果只是泛泛的说一下,可能就是一两句话.但是,我们的课程要遵循一个原则:知其然,知其所以然.所以,本小节的内容实际上有点多,但是我希望大家细细品味,争取彻底消化委托和事件这两个概念. 同时,本课程还要教会大家使用一个工具,分析代码. 二:委托的现实场景:卖家			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzyaVW4.html" rel="bookmark">零基础入门jQuery视频教程</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				零基础入门jQuery最新版开发.NET富客户端应用(选择器.DOM操作.事件和动画.Ajax应用.插件.Mobile)课程分类:.NET+Jquery适合人群:初级课时数量:35课时用到技术:javascript,ajax,jquery,handler涉及项目:各知识点的项目案例和名为JaneShop的品牌服装和包包的购物网站咨询qq:1840215592 零基础入门jQuery视频教程详细查看:http://www.ibeifeng.com/goods-425.html 零基础入门jQuer			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0RLkay4.html" rel="bookmark">干货分享：MySQL零基础入门视频教程！</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				首先给大家介绍一下数据库工程师,数据库工程师(Database Engineer),是从事管理和维护数据库管理系统(DBMS) 的相关工作人员的统称,他属于运维工程师的一个分支,主要负责业务数据库从设计.测试到部署交付的全生命周期管理.数据库工程师的核心目标是保证数据库管理系统的稳定性.安全性.完整性和高性能. 今天在这里给大家分享一个干货教程,MySQL零基础入门视频教程,希望能帮助到大家! 课程目录: 一. MySQL课程介绍和MySQL的基础概念(1)二. MySQL基础概念之存储引擎(2			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xxpwr0.html" rel="bookmark">Cloudera Manager、CDH零基础入门、线路指导 http&colon;&sol;&sol;www&period;aboutyun&period;com&sol;thread-9219-1-1&period;html &lpar;出处&colon; about云开发&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Cloudera Manager.CDH零基础入门.线路指导http://www.aboutyun.com/thread-9219-1-1.html(出处: about云开发) 问题导读:1.什么是cloudera CM .CDH?2.CDH.CM有哪些版本?3.CDH.CM有哪些安装方式?4.CDH如何开发? &lt;ignore_js_op&gt; 我们知道cloudera CDH 是为简化hadoop的安装,也对对hadoop做了一些封装.那么我们就像尝试学习cloudera.cloudera本质h			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3Od5pX4.html" rel="bookmark">&period;NET零基础入门09：SQL必知必会</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一:前言 仿佛到了更进一步的时候了,每一个程序员迟早都会遇到数据存储的问题.我们拿什么来存储程序产生的数据?举例来说,用什么来存储我们的打老鼠游戏每次的成绩呢?选择如下: 1:内存中.缺点,退出游戏,数据就没了: 2:文件中.好办法!缺点,自己解析文本,把文本变成我们程序中的数据,这个解析的过程叫做协议.协议这个词听上去够恐怖吧,实际上说白了无非就是数据格式怎么样,API接口怎么样之类的东东. 3:数据库.好办法!好吧,数据库文件其实也就是硬盘上的文件,只不过数据库本身就已经为我们定义好了数据格			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBmxQg4.html" rel="bookmark" class="title">HashMap&comma;LinkedHashMap&comma;TreeMap之间的区别</a>
					<div>
						Map 主要用于存储键(key)值(value)对,根据键得到值,因此键不允许键重复,但允许值重复. HashMap 是一个最常用的Map,它根据键的HashCode 值存储数据,根据键可以直接获取它 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3q5kp53.html" rel="bookmark" class="title">【转载wpf命令】</a>
					<div>
						出处:http://blog.csdn.net/fwj380891124 WPF学习之深入浅出话命令 分类:             WPF              2012-11-05 18:08 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mmlya14.html" rel="bookmark" class="title">&lbrack;转&rsqb;angular之&dollar;apply&lpar;&rpar;方法</a>
					<div>
						这几天,根据buddy指定的任务,要分享一点angular JS的东西.对于一个在前端属于纯新手的我来说,Javascript都还是一知半解,要想直接上手angular JS,遇到的阻力还真是不少.不 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWwZ6aM.html" rel="bookmark" class="title">JavaScript高级程序设计--对象，数组（栈方法，队列方法，重排序方法，迭代方法）</a>
					<div>
						1.使用对象字面量定义对象 var person={}; 使用这种方式创建对象时,实际上不会调用Object构造函数. 开发人员更喜欢对象字面量的语法. 2.有时候需要传递大量可选参数的情形时,一般来 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02DR7A4.html" rel="bookmark" class="title">c&sol;c&plus;&plus;常用代码 -- ini文件操作</a>
					<div>
						#pragma once #include &lt;string&gt; #include &lt;sstream&gt; typedef std::basic_string&lt;TCHAR&gt; ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0kpGaz3.html" rel="bookmark" class="title">好用的python代码练习工具jupyter-notebook安装及使用</a>
					<div>
						安装环境: 操作系统:Centos7-x86-64minimal 一.安装pyenv pyenv是python的多版本管理器,他能在系统上实现Python的多版本共存,但又不会影响系统自带的pytho ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JdrrV0.html" rel="bookmark" class="title">这是我写的一份简历模板</a>
					<div>
						&lt;!doctype html&gt; &lt;html lang=&quot;en&quot;&gt; &lt;head&gt; &lt;meta charset=&quot;UTF-8&quo ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVqDQ14.html" rel="bookmark" class="title">缓存限定登录次数</a>
					<div>
						package com.yjf.borncrm.web.util; import java.util.Calendar;import java.util.Date;import java.util.H ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k9lnb4.html" rel="bookmark" class="title">MS笔试中的一个关于函数返回的&OpenCurlyDoubleQuote;小&rdquo;题</a>
					<div>
						Which of following C++ code is correct ? A. int f() { int *a = new int(3); return *a; } B. int *f()  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXqwKX0.html" rel="bookmark" class="title">决定暂时放下 lisp</a>
					<div>
						学校嵌入式实验室开始招人了, 我也想了很久, 自己该走什么方向, 嵌入式? 服务器? 网站? 安卓? 仔细想想, 这些东西我连一个基础都不会. 我会了什么, C/C++语法, linux基本命令 这些 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49kZG10.html" rel="bookmark" class="title">nagios&lowbar;安装与配置</a>
					<div>
						2.安装与配置Nagios监控系统 2.1 创建nagios用户和组 #useradd -s /usr/sbin/nologin nagios #### 指定用户默认shell 没权限登录用户 #mk ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3Oy2AGM.html" rel="bookmark" class="title">11G ORACLE RAC DBCA 无法识别asm磁盘组</a>
					<div>
						ASM磁盘无法识别几种现象: 1) gi家目录或者其子目录权限错误 2)asm磁盘的权限错误 3)asm实例未启动或者asm磁盘组没有mount上 4)asm磁盘组资源没有在线 5)oracle用户的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoowxnM.html" rel="bookmark" class="title">【基于libRTMP的流媒体直播之 AAC、H264 推送】</a>
					<div>
						这段时间在捣腾基于 RTMP 协议的流媒体直播框架,其间参考了众多博主的文章,剩下一些细节问题自行琢磨也算摸索出个门道,现将自己认为比较恼人的 AAC 音频帧的推送和解析.H264 码流的推送和解析以 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWjoeL4.html" rel="bookmark" class="title">制作正式版10&period;11 OS X El Capitan 安装U盘（优盘）</a>
					<div>
						一.准备工作:1.准备一个 8GB 或以上容量的 U 盘,确保里面的数据已经妥善备份好(该过程会抹掉 U 盘全部数据)2.在你的程序应用文件夹中有刚刚从官网下载下来的 “安装 OS X El Capi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPXbdzM.html" rel="bookmark" class="title">加载selenium2Library失败---robotframework环境搭建（RIDE无法启动？）</a>
					<div>
						在robotframework升级的道路上遇到一些问题,记录下来方便以后查找问题 我的电脑之前安装的版本列表如下: python-2.7.5 robotframework-2.8.1 robotfra ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MoXmmn0.html" rel="bookmark" class="title">Nginx服务器开启GZip压缩的方法</a>
					<div>
						常用配置片段如下: gzip             on;gzip_comp_level  2;                        # 压缩比例,比例越大,压缩时间越长.默认是1gzip ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dDvew0.html" rel="bookmark" class="title">iOS中NSString常用操作合集</a>
					<div>
						//1.创建常量字符串. NSString *astring = @&quot;This is a String!&quot;; //2.创建空字符串,给予赋值. NSString *astring  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0k2vqEM.html" rel="bookmark" class="title">分享两段行列合并算法</a>
					<div>
						使用一个将指定行列的gridview横向纵向合并行列,实现多复杂表头样式 调用: GridCommon.Unitelist(this.grid1, 4); GridCommon.GroupCol(th ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVmXpd4.html" rel="bookmark" class="title">细细品味架构（第1期）&lowbar;实时计算在点评</a>
					<div>
						Hi,博友: 欢迎查阅&lt;细细品味架构&gt;系列,本系列将和我一起学习,并慢慢走近架构师的神秘世界. 本期目录: 1.本期内容... 3 1.1 版权申明... 3 1.2 内容详情... 3  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/ME7WzZ3.html" rel="bookmark" class="title">微信双开是定时炸弹？关于非越狱iOS上微信分身高危插件ImgNaix的分析</a>
					<div>
						作者:蒸米@阿里移动安全 序言 微信作为手机上的第一大应用,有着上亿的用户.并且很多人都不只拥有一个微信帐号,有的微信账号是用于商业的,有的是用于私人的.可惜的是官方版的微信并不支持多开的功能,并且频 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.031 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
